import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_GetImpersonationRoleEffectCommand, se_GetImpersonationRoleEffectCommand } from "../protocols/Aws_json1_1";
export { $Command };
export class GetImpersonationRoleEffectCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("WorkMailService", "GetImpersonationRoleEffect", {})
    .n("WorkMailClient", "GetImpersonationRoleEffectCommand")
    .f(void 0, void 0)
    .ser(se_GetImpersonationRoleEffectCommand)
    .de(de_GetImpersonationRoleEffectCommand)
    .build() {
}
